<template>
<section>
  <header class="header">
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet" />
  </header>
  <body>
    <div class="container">
      <h1 class="center-align">Watchlist</h1>
      <div class="row">
        <div class="col s12 m4 l4"></div>
        <div class="col s12 m4 l4">
          <ul class="collection">
            <p class="center-align" v-if="compteur == 0">Watchlist vide, ajouter des films</p>
            <li>
              <transition-group name="list">
                <a
                  v-for="movie in filterMovie"
                  :key="movie.name"
                  class="collection-item"
                  @click="watched(movie)"
                >
                  {{movie.name}}
                  <span
                    class="material-icons badge deleteBadge"
                    style="color: #ffffff;"
                    @click="deleteMovie(movie)"
                  >clear</span>
                  <span class="new badge teal" data-badge-caption>{{movie.genre}}</span>
                  <transition name="bounce">
                    <span v-if="movie.watched" class="material-icons badge">remove_red_eye</span>
                  </transition>
                </a>
              </transition-group>
            </li>
          </ul>
          <div class="filters">
            <label @click="filter = 'tout'">
              <input class="with-gap" name="group1" type="radio" />
              <span>Tout</span>
            </label>
            <label @click="filter = 'vue'">
              <input class="with-gap" name="group1" type="radio" />
              <span>Vue</span>
            </label>
            <label @click="filter = 'aVoir'">
              <input class="with-gap" name="group1" type="radio" />
              <span>À voir</span>
            </label>
          </div>
        </div>
      </div>
      <div class="divider"></div>
      <div class="row">
        <h1 class="center-align">Ajouter un Film</h1>
        <div class="col s12 m4 l4"></div>
        <div class="col s12 m4 l4">
          <div class="input-field">
            <form>
              <input type="text" placeholder="Titre" v-model="newMovieTitre" />
              <input type="text" placeholder="Genre" v-model="newMovieGenre" />
              <p>
                <label>
                  <input type="checkbox" v-model="newMovieWatched" />
                  <span>Film vue</span>
                </label>
              </p>
              <button
                class="btn waves-effect waves-light"
                @click="addMovie()"
                v-show="newMovieTitre && newMovieGenre"
              >
                Ajouter
                <i class="material-icons right">create</i>
              </button>
              <button
                class="btn waves-effect waves-light disabled"
                v-show="!newMovieTitre || !newMovieGenre"
              >
                Ajouter
                <i class="material-icons right">create</i>
              </button>
            </form>
          </div>
        </div>
      </div>
    </div>
  </body>
</section>
</template>

<script>
export default {
  data () {
    return {
      movies: [
        {
          name: 'E.T',
          genre: 'SF',
          watched: true
        },
        {
          name: 'Die Hard',
          genre: 'Action',
          watched: false
        }
      ],
      newMovieTitre: '',
      newMovieGenre: '',
      newMovieWatched: false,
      filter: 'all'
    }
  },
  methods: {
    addMovie () {
      this.movies.push({
        name: this.newMovieTitre,
        genre: this.newMovieGenre,
        watched: this.newMovieWatched
      })
      this.newMovieTitre = ''
      this.newMovieGenre = ''
      this.newMovieWatched = false
    },
    deleteMovie (movie) {
      this.movies = this.movies.filter(i => i !== movie)
    },
    watched (movie) {
      if (movie.watched === false) {
        movie.watched = true
      } else if (movie.watched === true) {
        movie.watched = false
      }
    }
  },
  computed: {
    filterMovie () {
      if (this.filter === 'aVoir') {
        return this.movies.filter(movie => !movie.watched)
      } else if (this.filter === 'vue') {
        return this.movies.filter(movie => movie.watched)
      }
      return this.movies
    },
    compteur () {
      return this.movies.length
    }
  }
}
</script>

<style>
.bounce-enter-active {
  animation: bounce-in 0.3s;
}
.bounce-leave-active {
  animation: bounce-in 0.3s reverse;
}
@keyframes bounce-in {
  0% {
    transform: scale(0);
  }
  50% {
    transform: scale(1.5);
  }
  100% {
    transform: scale(1);
  }
}
.list-item {
  display: inline-block;
  margin-right: 10px;
}
.list-enter-active,
.list-leave-active {
  transition: all 1s;
}
.list-enter,
.list-leave-to {
  opacity: 0;
  transform: translateY(30px);
}
</style>

<style src="./cine.css"></style>
